package main;

import utils.CommonUtils;
import utils.XRouteUtils;

import com.ptvag.jabba.core.exception.SystemException;
import com.ptvag.xserver.common.Point;
import com.ptvag.xserver.common.XServiceException;
import com.ptvag.xserver.xroute.DetailLevel;
import com.ptvag.xserver.xroute.Route;
import com.ptvag.xserver.xroute.XRouteException;
import com.ptvag.xserver.xroute.XRouteRemoteInterface;

public class XRouteSample {

	public static final String XROUTE_WS_URL = "http://localhost:50030/xroute/ws/XRoute";

	
	public static Point demoStart = CommonUtils.makePoint(685883, 6372994);
	public static Point demoDest  = CommonUtils.makePoint(681021, 6371667);
	
	public static Route runSampleRoutingDemo() {

		XRouteRemoteInterface client = XRouteUtils.makeClient(XROUTE_WS_URL);
		
		try {
			Route route = XRouteUtils.calcRoute(client, new Point[] { demoStart, demoDest }, DetailLevel.STANDARD);
			System.out.println("distance: " + route.getInfo().getDistance());
			System.out.println("time    : " + route.getInfo().getTime());
			int max = route.getPolygon().getLineString().getPoints().length;
			
			for (int i = 0; i < max; ++i) {
				System.out.println("polygon point("+ i + "): " + route.getPolygon().getLineString().getPoints()[i]);
			}
			
			return route;
		}
		catch (SystemException re) {
			System.err.println("Network or URL problem");
		}
		catch (XRouteException xre) {
			System.err.println("Problem calculating route");
		}
		catch (XServiceException xse) {
			System.err.println("Technical problem on server");
		}
		return null;

	}
	
	public static void main(String[] args) throws Exception {
		runSampleRoutingDemo();
	}
	
}
