/*******************************************************************************
 * PTV xServer - Code Samples
 * 
 * PTV AG grants you a non exclusive copyright license
 * to use all programming code examples from which you
 * can generate similar function tailored to your own
 * specific needs.
 * 
 * All sample code is provided by PTV AG for illustrative
 * purposes only. These examples have not been thoroughly
 * tested under all conditions. PTV AG, therefore, cannot
 * guarantee or imply reliability, serviceability, or
 * function of these programs.
 * 
 * All programs contained herein are provided to you
 * "AS IS" without any warranties of any kind. The implied
 * warranties of non-infringement, merchantability and
 * fitness for a particular purpose are expressly disclaimed.
 * 
 * (c) 2012 PTV AG
 ******************************************************************************/
package samples.xdima;

/*
 * PTV xServer Code Samples
 * 
 * PT xDima Server - Delete Dima
 * 
 * (c) 2012 PTV AG
 */
import utils.CommonUtils;
import utils.XDimaUtils;

import com.ptvag.jabba.core.exception.SystemException;
import com.ptvag.jabba.service.baseservices.CallerContext;
import com.ptvag.xserver.common.XServiceException;
import com.ptvag.xserver.xdima.XDimaException;
import com.ptvag.xserver.xdima.XDimaRemoteInterface;

public class DimaDelete {

    private static void runSample() {

	// Step 1: Initialize PTV xDima client using the client factory in package utils
	String URL = "http://127.0.0.1:50070/xdima/ws/XDima";
	XDimaRemoteInterface xDimaClient = XDimaUtils.makeClient(URL);

	// Step 2: Create a new CallerContext using class CommonUtils(profile, log1, log2, log3)
	CallerContext ctx = CommonUtils.makeContext("default", "PTV AG", "PTV xDima Server",
		"DeleteDima()");
	xDimaClient.setCallerContext(ctx);

	// Step 3. Select existing dimaID in order to delete the correct Dima<1001>.
	int dimaID = 1001;

	try {
	    // Step 4: call method deleteDima(). Corresponding folder (e.g. 0000) will be deleted in directory "basic_path/data/dima".
			System.out.println("Start to delete dima<1001>...");
	    xDimaClient.deleteDima(dimaID);
	    System.out.println("Dima <1001> is deleted.");
	} catch (SystemException se) {
	    System.err.println("Network or URL problem");
	} catch (XDimaException xse) {
	    System.err.println("Problem creating dima profile");
	    System.out.println(xse.getMessage());
	} catch (XServiceException xsse) {
	    System.err.println("Technical problem on server");
	    System.out.println("Exception:\n" + xsse);
	}
    }

    public static void main(String[] args) {
	runSample();
    }
}
