/*******************************************************************************
 * PTV xServer - Code Samples
 * 
 * PTV AG grants you a non-exclusive copyright license
 * to use all programming code examples from which you
 * can generate similar function tailored to your own
 * specific needs.
 * 
 * All sample code is provided by PTV AG for illustrative
 * purposes only. These examples have not been thoroughly
 * tested under all conditions. PTV AG, therefore, cannot
 * guarantee or imply reliability, serviceability, or
 * function of these programs.
 * 
 * All programs contained herein are provided to you
 * "AS IS" without any warranties of any kind. The implied
 * warranties of non-infringement, merchantability and
 * fitness for a particular purpose are expressly disclaimed.
 * 
 * (c) 2012 PTV AG
 ******************************************************************************/
package samples.xdima;

/*
 * PTV xServer Code Samples
 * 
 * PT xDima Server - Export Dima
 * 
 * (c) 2012 PTV AG
 */
import utils.CommonUtils;
import utils.XDimaUtils;

import com.ptvag.jabba.core.exception.SystemException;
import com.ptvag.jabba.service.baseservices.CallerContext;
import com.ptvag.xserver.common.XServiceException;
import com.ptvag.xserver.xdima.FileType;
import com.ptvag.xserver.xdima.XDimaException;
import com.ptvag.xserver.xdima.XDimaRemoteInterface;

public class DimaExport {

	private static void runSample() {

		// Step 1: Initialize PTV xDima client using the client factory in package
		// utils.
		String URL = "http://localhost:50070/xdima/ws/XDima";
		XDimaRemoteInterface xDimaClient = XDimaUtils.makeClient(URL);

		// Step 2: Define caller context and also use the package utils.
		CallerContext ctx = CommonUtils.makeContext("default", "PTV GROUP", "PTV xDima Server", "exportDima()");
		xDimaClient.setCallerContext(ctx);

		// Step 3: Set the existing dima ID
		int dimaID = 1001;

		try {
			// Step 4: Call method exportDima()
			System.out.println("Start to export Dima...");
			xDimaClient.exportDima(dimaID, FileType.TEXT_ASCII, "locationTable.txt", "distanceTable.txt");		
			// Step 5: Output lies in the corresponding folder of PTV xDima Server.  
			System.out.println("Dima <ID=1001> is found. Check your output in ./dima/output");
		} catch (SystemException se) {
			System.err.println("Network or URL problem");
		} catch (XDimaException xse) {
			System.err.println("Problem creating dima profile");
			System.out.println(xse.getMessage());
		} catch (XServiceException xsse) {
			System.err.println("Technical problem on server");
			System.out.println("Exception:\n" + xsse);
		}
	}

	public static void main(String[] args) {
		runSample();
	}
}
