package samples.xlocate.advanced;

import utils.XLocateUtils;

import com.ptvag.xserver.common.GeometryEncoding;
import com.ptvag.xserver.xlocate.Address;
import com.ptvag.xserver.xlocate.AddressResponse;
import com.ptvag.xserver.xlocate.ResultAddress;
import com.ptvag.xserver.xlocate.XLocateRemoteInterface;
import com.ptvag.jabba.service.baseservices.CallerContext;
import com.ptvag.jabba.service.baseservices.CallerContextProperty;

/*******************************************************************************
 * PTV xServer - Code Samples
 * 
 * PTV AG grants you a non exclusive copyright license to use all programming
 * code examples from which you can generate similar function tailored to your
 * own specific needs.
 * 
 * All sample codes are provided by PTV Group for illustrative purposes only.
 * These examples have not been thoroughly tested under all conditions.
 * Therefore, PTV Group cannot guarantee or imply reliability, service ability
 * or function of these programs.
 * 
 * All programs contained herein are provided to you "AS IS" without any
 * warranties of any kind. The implied warranties of non-infringement, merchant
 * ability and fitness for a particular purpose are expressly disclaimed.
 * 
 * (c) 2014 PTV AG
 ******************************************************************************/

/*
 * PTV xServer Code Samples
 * 
 * PT xLocate Server - find address using various profiles
 * 
 * (c) 2014 PTV AG
 */
public class GeocodingWithDifferentProfile {

	public static void runSample() {
		
		/*
		 * use the utils package for instantiate the clientfactory 
		 */
		final String XLOCATE_WS_URL = "http://localhost:50020/xlocate/ws/XLocate";
		
		XLocateRemoteInterface xLocateClient = XLocateUtils.makeClient(XLOCATE_WS_URL);
		setCallerContext(xLocateClient);

		//-------------------------------------------------------------
		// 1. Define an address
		//final Address COUNTRY_CITY  = XLocateUtils.makeAddress("L~~~Luxembourg~~~~");
		//final Address COUNTRY_ZIP_ADDR_STREET = XLocateUtils.makeAddress("L~~1856~Luxembourg~~Rue Evrard Ketten~");
		final Address ADDR_ALL = XLocateUtils.makeAddress("L~~1856~Luxembourg~~Rue Evrard Ketten~40");
		
		// Depending on how complete your address is
		// you get none, one or multiple results
		
		
		try {
			//-------------------------------------------------------------
			// 2. Define an address
			AddressResponse response = 
				xLocateClient.findAddress(ADDR_ALL, null, null, null);
				//xLocateClient.findAddress(COUNTRY_ZIP_ADDR_STREET, null, null, null);
				//xLocateClient.findAddress(ADDR_ALL, null, null, null);

			for (ResultAddress resAddr : response.getResultList()) {
				System.out.println(String.format(
								"X: %.2f\t Y: %.2f",
								resAddr.getCoordinates().getPoint().getX(),
								resAddr.getCoordinates().getPoint().getY()
								));
			}

		} catch (Exception e) {
			// TODO proper exception handling 
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		runSample();
	}
	
	private static void setCallerContext(XLocateRemoteInterface xLocateClient) {
		CallerContext ctx = new CallerContext();
		ctx.setLog1("Test");
		ctx.setLog2("user");
		ctx.setLog3("");

		// 3. define properties for the Caller Context
		CallerContextProperty ctxprop1 = new CallerContextProperty();
		ctxprop1.setKey("CoordFormat");
		ctxprop1.setValue("PTV_MERCATOR");
		
		CallerContextProperty ctxprop2 = new CallerContextProperty();
		ctxprop2.setKey("ResponseGeometry");
		ctxprop2.setValue(GeometryEncoding.PLAIN.getValue());
		
		CallerContextProperty ctxprop3 = new CallerContextProperty();
		ctxprop3.setKey("Profile");
		ctxprop3.setValue("fuzzy");
		
		CallerContextProperty[] prop = { ctxprop1, ctxprop2, ctxprop3 };
		// CallerContextProperty[] prop = {ctxprop1};
		ctx.setProperties(prop);
		xLocateClient.setCallerContext(ctx);

	}

}
