package samples.xlocate.advanced;

import utils.XLocateUtils;

import com.ptvag.xserver.xlocate.Address;
import com.ptvag.xserver.xlocate.AddressResponse;
import com.ptvag.xserver.xlocate.ResultAddress;
import com.ptvag.xserver.xlocate.XLocateRemoteInterface;

/*******************************************************************************
 * PTV xServer - Code Samples
 * 
 * PTV AG grants you a non exclusive copyright license to use all programming
 * code examples from which you can generate similar function tailored to your
 * own specific needs.
 * 
 * All sample codes are provided by PTV Group for illustrative purposes only.
 * These examples have not been thoroughly tested under all conditions.
 * Therefore, PTV Group cannot guarantee or imply reliability, service ability
 * or function of these programs.
 * 
 * All programs contained herein are provided to you "AS IS" without any
 * warranties of any kind. The implied warranties of non-infringement, merchant
 * ability and fitness for a particular purpose are expressly disclaimed.
 * 
 * (c) 2014 PTV AG
 ******************************************************************************/

/*
 * PTV xServer Code Samples
 * 
 * PT xLocate Server - find address taking authentication into account
 * 
 * (c) 2014 PTV AG
 */
public class RequestWithAuthentication {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		final String XLOCATE_URL = "http://localhost:50020/xlocate/ws/XLocate";
		XLocateRemoteInterface xLocateClient = XLocateUtils.makeClient(XLOCATE_URL);
		
		// authentication has to be configured before. Create the users.properties file 
		// in the xlocate/conf-folder and integrate:
		// dummyUser=secret_password
		xLocateClient.setUsername("dummyUser");
		xLocateClient.setPassword("secret_password");
			
		final Address ADDR_COUNTRY_CITY  = XLocateUtils.makeAddress("L~~~Luxembourg~~~~");
		
		try {
			AddressResponse response = 
				xLocateClient.findAddress(ADDR_COUNTRY_CITY, null, null, null);

			for (ResultAddress resAddr : response.getResultList()) {
				System.out.println(String.format(
								"X: %.2f\t Y: %.2f",
								resAddr.getCoordinates().getPoint().getX(),
								resAddr.getCoordinates().getPoint().getY()
								));
			}

		} catch (Exception e) {
			// TODO proper exception handling 
			e.printStackTrace();
		}

	}

}
