package samples.xlocate.advanced;

/*******************************************************************************
 * PTV xServer - Code Samples
 * 
 * PTV AG grants you a non exclusive copyright license to use all programming
 * code examples from which you can generate similar function tailored to your
 * own specific needs.
 * 
 * All sample codes are provided by PTV Group for illustrative purposes only.
 * These examples have not been thoroughly tested under all conditions.
 * Therefore, PTV Group cannot guarantee or imply reliability, service ability
 * or function of these programs.
 * 
 * All programs contained herein are provided to you "AS IS" without any
 * warranties of any kind. The implied warranties of non-infringement, merchant
 * ability and fitness for a particular purpose are expressly disclaimed.
 * 
 * (c) 2014 PTV AG
 ******************************************************************************/

/*
 * PTV xServer Code Samples
 * 
 * PT xLocate Server - find some given addresses
 * 
 * (c) 2014 PTV AG
 */
import utils.XLocateUtils;

import com.ptvag.jabba.core.exception.SystemException;
import com.ptvag.xserver.common.XServiceException;
import com.ptvag.xserver.xlocate.Address;
import com.ptvag.xserver.xlocate.ResultAddress;
import com.ptvag.xserver.xlocate.XLocateException;
import com.ptvag.xserver.xlocate.XLocateRemoteInterface;

public class XLocateSample {

	public static final String XLOCATE_WS_URL = "http://localhost:50020/xlocate/ws/XLocate";
	
	public static final Address ADDR_COUNTRY_AND_CITY       = XLocateUtils.makeAddress("L~~~Bech~~~~");
	public static final Address ADDR_COUNTRY_ZIP_AND_STREET = XLocateUtils.makeAddress("L~~1121~~~Alouettes~~");

	public static void runSimpleGeocodingDemo() {
		
		XLocateRemoteInterface client = XLocateUtils.makeClient(XLOCATE_WS_URL);

		ResultAddress[] results;
		
		try {
			System.out.println("geocoding address: " + ADDR_COUNTRY_AND_CITY);
			results = client.findAddress(ADDR_COUNTRY_AND_CITY, null, null, null).getResultList();
			System.out.println("found " + results.length + " candidates");
			if (results.length > 0) {
				System.out.println("first is: " + results[0]);
			}

			System.out.println("geocoding address: " + ADDR_COUNTRY_ZIP_AND_STREET);
			results = client.findAddress(ADDR_COUNTRY_ZIP_AND_STREET, null, null, null).getResultList();
			System.out.println("found " + results.length + " candidates");
			if (results.length > 0) {
				System.out.println("first is: " + results[0]);
			}
		}
		catch (SystemException se) {
			System.err.println("Network or URL problem");
		}
		catch (XLocateException xle) {
			System.err.println("Problem geocoding address");
		}
		catch (XServiceException xse) {
			System.err.println("Technical problem on server");
			System.out.println("Exception:\n" + xse);
		}

	}

	public static void main(String[] args) {
		runSimpleGeocodingDemo();
	}

}
