/*******************************************************************************
 * PTV xServer - Code Samples
 *
 * PTV AG grants you a nonexclusive copyright license
 * to use all programmingcode examples from which you
 * can generate similar function tailored to your own
 * specific needs.
 *
 * All sample code is provided by PTV AG for illustrative
 * purposes only. These examples have not been thoroughly
 * tested under all conditions. PTV AG, therefore, cannot
 * guarantee or imply reliability, serviceability, or
 * function of these programs.
 *
 * All programs contained herein are provided to you
 * "AS IS" without any warranties of any kind. The implied
 * warranties of non-infringement, merchantability and
 * fitness for a particular purpose are expressly disclaimed.
 *
 * (c) 2009 PTV AG
 ******************************************************************************/
package samples.xroute.advanced;

import utils.XRouteUtils;

import com.ptvag.xserver.common.PlainPoint;
import com.ptvag.xserver.common.Point;
import com.ptvag.xserver.xroute.MatrixInfo;
import com.ptvag.xserver.xroute.RouteInfo;
import com.ptvag.xserver.xroute.WaypointDesc;
import com.ptvag.xserver.xroute.XRouteRemoteInterface;

public class RoutingWithMatrixInfo {

    public static void main(String[] args) {
        runSample();
    }

    private static void runSample() {
        // set a HTTP proxy if required
        /*System.getProperties().setProperty("http.proxySet", "true");
        System.getProperties().setProperty("http.proxyHost","localhost");
        System.getProperties().setProperty("http.proxyPort", "8888");*/

    	String XROUTE_WS_URL = "http://localhost:50030/xroute/ws/XRoute";
		XRouteRemoteInterface xRouteClient = XRouteUtils.makeClient(XROUTE_WS_URL);

        WaypointDesc[] startWPs = new WaypointDesc[2];
        // Rue Principale 27
        // L-5240 Sandweiler
        Point point1 = new Point();
		point1.setPoint( new PlainPoint(691495.7, 6372987.6, null) );
		
        startWPs[0] = new WaypointDesc();
        startWPs[0].setCoords(new Point[] { point1 });
        // Steil 2
        // L-9651 Eschweiler
        Point point2 = new Point();
		point2.setPoint( new PlainPoint(661614.3, 6438775.4, null) );
        startWPs[1] = new WaypointDesc();
        startWPs[1].setCoords(new Point[] { point2 });

        WaypointDesc[] destWPs = new WaypointDesc[3];
        // Rue du Nord 16
        // L-8806 Rambrouch
        Point point3 = new Point();
		point3.setPoint( new PlainPoint(650023.3, 6410109.7, null) );
        destWPs[0] = new WaypointDesc();
        destWPs[0].setCoords(new Point[] { point3 });
        // Burrewee 3
        // L-9760 Wilwerwiltz
        Point point4 = new Point();
		point4.setPoint( new PlainPoint(668520.6, 6436053.1, null) );
        destWPs[1] = new WaypointDesc();
        destWPs[1].setCoords(new Point[] { point4 });
        // Rue des Violettes 10
        // L-4940 Bascharage
        Point point5 = new Point();
		point5.setPoint( new PlainPoint(657647.9, 6365485.9, null) );
        destWPs[2] = new WaypointDesc();
        destWPs[2].setCoords(new Point[] { point5 });

        try {
            MatrixInfo matrixInfo = xRouteClient.calculateMatrixInfo(startWPs, destWPs, null, null);
            String inforoute = "";
            int index = 0;
            // print out calculated information
            for( RouteInfo routeInfo : matrixInfo.getMatrixInfo()) {
            	++index;
            	inforoute = ("Route["+index+"]\t" + "Cost: "+routeInfo.getCost()+"\tDistance: "+routeInfo.getDistance()
            			+ "\t\tTime: "+routeInfo.getTime());
            	System.out.println(inforoute);
            }

        }catch(Exception e){
            // TODO proper exception handling
            e.printStackTrace();
        }
    }

}
