package utils;

public class Coordinates_Transformation {

    public static double[] Mercator_2_GeoDecimal(double xIn, double yIn)
    {
		double[] xyOut = new double[2];

        double xArg = xIn, yArg = yIn;

        {
            double lambda, phi;
            lambda = (180 / Math.PI) * (xArg / 6371000.0 + 0.0);
            phi = (180 / Math.PI) * (Math.atan(Math.exp(yArg / 6371000.0)) - (Math.PI / 4)) / 0.5;
            xArg = lambda;
            yArg = phi;
        }
        {
            xArg = xArg * 100000;
            yArg = yArg * 100000;
        }

        xyOut[0] = xArg;
        xyOut[1] = yArg;
        return xyOut;
    }

    public static double[] Mercator_2_GeoMinSec(double xIn, double yIn)
    {
		double[] xyOut = new double[2];
        double xArg = xIn, yArg = yIn;

        {
            double lambda, phi;
            lambda = (180 / Math.PI) * (xArg / 6371000.0 + 0.0);
            phi = (180 / Math.PI) * (Math.atan(Math.exp(yArg / 6371000.0)) - (Math.PI / 4)) / 0.5;
            xArg = lambda;
            yArg = phi;
        }
        {
            xArg = xArg * 100000;
            yArg = yArg * 100000;
        }

        {
            double deg, min, sec, tmp;
            int vz;
            if (xArg >= 0)
            {
                vz = 1;
            }
            else
            {
                vz = -1;
                xArg = -xArg;
            }
            deg = (double)(int)(xArg / 100000);
            min = ((xArg / 100000) - deg) * 60;
            tmp = (double)(int)min;
            sec = (min - tmp) * 600;
            min = tmp;
            xArg = (deg * 100000 + min * 1000 + sec) * vz;
        }
        {
            double deg, min, sec, tmp;
            int vz;
            if (yArg >= 0)
            {
                vz = 1;
            }
            else
            {
                vz = -1;
                yArg = -yArg;
            }
            deg = (double)(int)(yArg / 100000);
            min = ((yArg / 100000) - deg) * 60;
            tmp = (double)(int)min;
            sec = (min - tmp) * 600;
            min = tmp;
            yArg = (deg * 100000 + min * 1000 + sec) * vz;
        }
        xyOut[0] = xArg;
        xyOut[1] = yArg;
        return xyOut;
    }

    public static double[] GeoDecimal_2_Mercator(double xIn, double yIn)
    {
		double[] xyOut = new double[2];

        double xArg = xIn, yArg = yIn;

        {
            xArg = xArg / 100000;
            yArg = yArg / 100000;
        }
        {
            double lambda, phi;
            lambda = xArg;
            phi = yArg;
            xArg = 6371000.0 * ((Math.PI / 180) * ((lambda) - 0.0));
            yArg = 6371000.0 * Math.log(Math.tan((Math.PI / 4) + (Math.PI / 180) * phi * 0.5));
        }

        xyOut[0] = xArg;
        xyOut[1] = yArg;
        return xyOut;
    }

    public static double[] GeoDecimal_2_GeoMinSec(double xIn, double yIn)
    {
		double[] xyOut = new double[2];

        double xArg = xIn, yArg = yIn;
        {
            double deg, min, sec, tmp;
            int vz;
            if (xArg >= 0)
            {
                vz = 1;
            }
            else
            {
                vz = -1;
                xArg = -xArg;
            }
            deg = (double)(int)(xArg / 100000);
            min = ((xArg / 100000) - deg) * 60;
            tmp = (double)(int)min;
            sec = (min - tmp) * 600;
            min = tmp;
            xArg = (deg * 100000 + min * 1000 + sec) * vz;
        }
        {
            double deg, min, sec, tmp;
            int vz;
            if (yArg >= 0)
            {
                vz = 1;
            }
            else
            {
                vz = -1;
                yArg = -yArg;
            }
            deg = (double)(int)(yArg / 100000);
            min = ((yArg / 100000) - deg) * 60;
            tmp = (double)(int)min;
            sec = (min - tmp) * 600;
            min = tmp;
            yArg = (deg * 100000 + min * 1000 + sec) * vz;
        }
        xyOut[0] = xArg;
        xyOut[1] = yArg;
        return xyOut;
    }

    public static double[] GeoMinSec_2_Mercator(double xIn, double yIn)
    {
		double[] xyOut = new double[2];

        double xArg = xIn, yArg = yIn;
        {
            double deg, min, sec, tmp;
            int vz;
            if (xArg >= 0)
            {
                vz = 1;
            }
            else
            {
                vz = -1;
                xArg = -xArg;
            }
            deg = (double)(int)(xArg / 100000);
            min = ((xArg / 100000) - deg) * 100;
            tmp = (double)(int)min;
            sec = (min - tmp) * 100;
            min = tmp;
            xArg = (deg * 100000 + (min * 60 + sec) / 0.036) * vz;
        }
        {
            double deg, min, sec, tmp;
            int vz;
            if (yArg >= 0)
            {
                vz = 1;
            }
            else
            {
                vz = -1;
                yArg = -yArg;
            }
            deg = (double)(int)(yArg / 100000);
            min = ((yArg / 100000) - deg) * 100;
            tmp = (double)(int)min;
            sec = (min - tmp) * 100;
            min = tmp;
            yArg = (deg * 100000 + (min * 60 + sec) / 0.036) * vz;
        }

        {
            xArg = xArg / 100000;
            yArg = yArg / 100000;
        }
        {
            double lambda, phi;
            lambda = xArg;
            phi = yArg;
            xArg = 6371000.0 * ((Math.PI / 180) * ((lambda) - 0.0));
            yArg = 6371000.0 * Math.log(Math.tan((Math.PI / 4) + (Math.PI / 180) * phi * 0.5));
        }

        xyOut[0] = xArg;
        xyOut[1] = yArg;
        return xyOut;
    }

    public static double[] GeoMinSec_2_GeoDecimal(double xIn, double yIn)
    {
		double[] xyOut = new double[2];

        double xArg = xIn, yArg = yIn;
        {
            double deg, min, sec, tmp;
            int vz;
            if (xArg >= 0)
            {
                vz = 1;
            }
            else
            {
                vz = -1;
                xArg = -xArg;
            }
            deg = (double)(int)(xArg / 100000);
            min = ((xArg / 100000) - deg) * 100;
            tmp = (double)(int)min;
            sec = (min - tmp) * 100;
            min = tmp;
            xArg = (deg * 100000 + (min * 60 + sec) / 0.036) * vz;
        }
        {
            double deg, min, sec, tmp;
            int vz;
            if (yArg >= 0)
            {
                vz = 1;
            }
            else
            {
                vz = -1;
                yArg = -yArg;
            }
            deg = (double)(int)(yArg / 100000);
            min = ((yArg / 100000) - deg) * 100;
            tmp = (double)(int)min;
            sec = (min - tmp) * 100;
            min = tmp;
            yArg = (deg * 100000 + (min * 60 + sec) / 0.036) * vz;
        }
        xyOut[0] = xArg;
        xyOut[1] = yArg;
        return xyOut;
    }

    public static double distanceFromMercator(double x1, double y1, double x2, double y2){
    	double dx = x2 - x1;
    	double dy = y2 - y1;
    	double Y, B, distance;
    	
    	Y = 0.5*(y2 + y1);
    	B = 2.0 * Math.atan(Math.exp(Y/6371000.0)) - (0.5 * Math.PI);
    	distance = Math.cos(B)*Math.sqrt(Math.pow(dx,2)+Math.pow(dy, 2));
    	
    	return distance;	
    }
    
    public static double distance(double x1, double y1, double x2, double y2){
    	double dx = x2 - x1;
    	double dy = y2 - y1;
    	
    	double distance = Math.sqrt(Math.pow(dx,2)+Math.pow(dy, 2));
    	
    	return distance;	
    }
    
    public static double[] Mercator_2_SmartUnits(double xIn, double yIn) {
		double[] xyOut = new double[2];
		double offset = 20015087;
		double R = 6371000;
		double constant = (2 * Math.PI * R) / (254 * Math.pow(2, 15));

		xyOut[0] = (xIn + offset) / constant;
		xyOut[1] = (yIn + offset) / constant;

		return xyOut;
	}
}
