package utils;

import java.util.Vector;

import com.ptvag.jabba.service.baseservices.CallerContext;
import com.ptvag.jabba.service.baseservices.ClientFactory;
import com.ptvag.jabba.service.baseservices.RemoteType;
import com.ptvag.xserver.xcluster.XClusterRemoteInterface;

public class XClusterUtils {
	private XClusterUtils() {
		// this is a utility class!
	}

	public static XClusterRemoteInterface makeClient(String url) {
		XClusterRemoteInterface client = (XClusterRemoteInterface) ClientFactory.createClient(
				XClusterRemoteInterface.class, RemoteType.DOCSTYLE_CXF, "", "", url);
		CallerContext cc = CommonUtils.makeDefaultContext();
		client.setCallerContext(cc);
		client.setUsername("user");
		client.setPassword("pwd");
		return client;
	}

	public static Vector<String> getSubStrings(String arg0) {
		char arg1 = ';';

		Vector<String> subStrings = new Vector<String>();
		int k = 0;
		int max = arg0.length();
		String elem = "";

		for (int i = 0; i < max; i++) {
			if (arg0.charAt(i) == arg1) {
				elem = arg0.substring(k, i);
				if (!elem.equals("")) {
					subStrings.addElement(elem);
				}
				k = i + 1;
			} else if (i == max - 1) {
				elem = arg0.substring(k, max);
				if (!elem.equals("")) {
					subStrings.addElement(elem);
				}
			}
		}

		return subStrings;
	}

	public static Vector<Integer> getQuantities(String arg0) {
		char arg1 = '~';
		int k = 0;
		int max = arg0.length();
		int elem = 0;
		Vector<Integer> quantity = new Vector<Integer>();

		for (int i = 0; i < max; i++) {
			if (arg0.charAt(i) == arg1) {
				elem = stringtoint(arg0.substring(k, i));
				quantity.addElement(elem);
				k = i + 1;
			} else if (i == max - 1) {
				elem = stringtoint(arg0.substring(k, max));
				quantity.addElement(elem);
			}
		}

		return quantity;
	}

	public static int stringtoint(String zahl) throws NumberFormatException {
		Integer number = new Integer(zahl);
		int num = number.intValue();
		return num;
	}

	public static int stringtoInteger(String zahl) throws NumberFormatException {
		Integer number = new Integer(zahl);
		return number;
	}

	public static double stringtodouble(String zahl) throws NumberFormatException {
		Double number = new Double(zahl);
		double num = number.doubleValue();
		return num;
	}

}
