package utils;

import java.rmi.RemoteException;

import com.ptvag.jabba.core.exception.SystemException;
import com.ptvag.jabba.service.baseservices.CallerContext;
import com.ptvag.jabba.service.baseservices.ClientFactory;
import com.ptvag.jabba.service.baseservices.RemoteType;
import com.ptvag.xserver.common.XServiceException;
import com.ptvag.xserver.xlocate.Address;
import com.ptvag.xserver.xlocate.ResultAddress;
import com.ptvag.xserver.xlocate.XLocateException;
import com.ptvag.xserver.xlocate.XLocateRemoteInterface;


/**
 * this utility class contains static methods for xlocate convenience
 * 
 * @author RN
 */
public class XLocateUtils {

	private XLocateUtils() {
		// this is a utility class!
	}
	
	public static XLocateRemoteInterface makeClient(String url) {
		XLocateRemoteInterface client = (XLocateRemoteInterface)ClientFactory.createClient(XLocateRemoteInterface.class,RemoteType.DOCSTYLE_CXF,"","",url);
		CallerContext cc = CommonUtils.makeDefaultContext();
		client.setCallerContext(cc);
        client.setUsername("user");
        client.setPassword("pwd");
		return client;
	}
	
	/**
	 * creates an address from a string that uses '~' as word separator.
	 * The string must have the format "country~state~zip~city~district~street~housenr".
	 * Caution: this method is really anything but failsafe!
	 * @param addrStr the address string
	 * @return the according address
	 */
	public static Address makeAddress(String addrStr) {
		Address res = new Address();
		String[] parts = (addrStr + "~~~~~~~.").split("~");
		res.setCountry(parts[0]);
		res.setState(parts[1]);
		res.setPostCode(parts[2]);
		res.setCity(parts[3]);
		res.setCity2(parts[4]);
		res.setStreet(parts[5]);
		res.setHouseNumber(parts[6]);
		return res;
	}

	public static ResultAddress[] geocodeAddress(XLocateRemoteInterface client, Address addr) throws SystemException, XServiceException, XLocateException, RemoteException {
        return client.findAddress(addr, null, null, null).getResultList();
	}
	
}
