package utils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Vector;

import com.ptvag.jabba.service.baseservices.CallerContext;
import com.ptvag.jabba.service.baseservices.ClientFactory;
import com.ptvag.jabba.service.baseservices.RemoteType;
import com.ptvag.xserver.common.PlainPoint;
import com.ptvag.xserver.common.Point;
import com.ptvag.xserver.xmapmatch.XMapmatchRemoteInterface;

public class XMapMatchUtils {
	private XMapMatchUtils() {
		// this is a utility class!
	}

	public static XMapmatchRemoteInterface makeClient(String url) {
		XMapmatchRemoteInterface client = (XMapmatchRemoteInterface) ClientFactory
				.createClient(XMapmatchRemoteInterface.class,
						RemoteType.DOCSTYLE_CXF, "", "", url);
		CallerContext cc = CommonUtils.makeDefaultContext();
		client.setCallerContext(cc);
		client.setUsername("user");
		client.setPassword("pwd");
		return client;
	}
	
	public static Vector<String> getSubStrings(String arg0) {
		char arg1 = ';';

		Vector<String> subStrings = new Vector<String>();
		int k = 0;
		int max = arg0.length();
		String elem = "";

		for (int i = 0; i < max; i++) {
			if (arg0.charAt(i) == arg1) {
				elem = arg0.substring(k, i);
				if (!elem.equals("")) {
					subStrings.addElement(elem);
				}
				k = i + 1;
			} else if (i == max - 1) {
				elem = arg0.substring(k, max);
				if (!elem.equals("")) {
					subStrings.addElement(elem);
				}
			}
		}

		return subStrings;
	}
	
	public static int stringtoint(String zahl) throws NumberFormatException {
		Integer number = new Integer(zahl);
		int num = number.intValue();
		return num;
	}

	public static double stringtodouble(String zahl) throws NumberFormatException {
		Double number = new Double(zahl);
		double num = number.doubleValue();
		return num;
	}

	public static float stringtofloat(String zahl) throws NumberFormatException {
		Float number = new Float(zahl);
		float num = number.floatValue();
		return num;
	}

	public static boolean stringtoboolean(String bool) throws NumberFormatException {
		Boolean test = new Boolean(bool);
		boolean ok = test.booleanValue();
		return ok;
	}
	
	public static Point stringtopoint(String arg0, String arg1) throws NumberFormatException {
		Double num0 = new Double(arg0); 
		Double num1 = new Double(arg1);
		
		double lon = num0.doubleValue();
		double lat = num1.doubleValue();
		
		PlainPoint plainPoint = new PlainPoint();
		plainPoint.setX(lon);
		plainPoint.setY(lat);
		plainPoint.setZ(null);
		
		Point point = new Point();
		point.setPoint(plainPoint);
		
		return point;
	}
	
	public static Calendar stringtocalendar(String arg0) throws ParseException {
		String pattern = "yyyy-MM-dd'T'HH:mm:ss.SSSZ";
        SimpleDateFormat sdf = new SimpleDateFormat(pattern);
        
        Date date = sdf.parse(arg0);
        
        Calendar timestamp = Calendar.getInstance();
        timestamp.setTime(date);
        
		return timestamp;
	}
	
	
	public static String inttostring(int zahl) throws NumberFormatException{
		// wrapper (Double, Integer, Long, Byte, Bolean, Character, Float)
		Integer num = new Integer(zahl);
		String ergebnis = num.toString();
		return ergebnis;
	}

	public static String doubletostring(double zahl) throws NumberFormatException{
		// wrapper (Double, Integer, Long, Byte, Bolean, Character, Float)
		Double num = new Double(zahl);
		String ergebnis = num.toString();
		return ergebnis;
	}

	public static String floattostring(float zahl) throws NumberFormatException{
		// wrapper (Double, Integer, Long, Byte, Bolean, Character, Float)
		Float num = new Float(zahl);
		String ergebnis = num.toString();
		return ergebnis;
	}
	
	public static String longtostring(long zahl) throws NumberFormatException{
		// wrapper (Double, Integer, Long, Byte, Bolean, Character, Float)
		Long num = new Long(zahl);
		String ergebnis = num.toString();
		return ergebnis;
	}

	public static String booleantostring(boolean bool) {
		// wrapper (Double, Integer, Long, Byte, Bolean, Character, Float)
		Boolean test = new Boolean(bool);
		String ergebnis = test.toString();
		return ergebnis;
	}

	public static int doubletoint(double zahl) {
		// cast (byte, short, int, long, float, double)
		int num = (int) Math.round(zahl);
		return num;
	}
	
}
